// $Id: djinniprocess-internal.h,v 1.1 2003/11/04 22:32:40 ensc Exp $    --*- c -*--

// Copyright (C) 2003 Enrico Scholz <enrico.scholz@informatik.tu-chemnitz.de>
//  
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; version 2 of the License.
//  
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//  
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.


#ifndef H_VSERVER_DJINNIE_SRC_DJINNIPROCESS_RUN_H
#define H_VSERVER_DJINNIE_SRC_DJINNIPROCESS_RUN_H

#include "credentials.h"
#include <stdbool.h>

struct DjinniProcess
{
    char const *	state_dir;			//< /var/state/djinnid/...
    int			dirfd_root;			//< fd of '/'
    int			dirfd_state;			//< fd of current statedir
    int			dirfd_vserver;			//< fd of vserver topdir
    
    int			fd_cmd_vserver;			//< commands from the vserver
    int			fd_cmd_master;			//< commands from the host
    int			fd_heartbeat_vserver;		//< keep-alive from vserver; initially, it is the listen-socket, then it becomes the connected socket
    int			fd_heartbeat_children[2];	//< my keep-alive to children
    int			fd_parent;			//< parent->fd_heartbeat_children[0] or top-level hearbeat-fd

    bool		is_alive;
    bool		is_trusted;
    
    struct DjinniProcess const *parent;			//< parent or NULL for root
    
    struct {
	struct Credentials	v;
	bool			f;
    }			credentials;
};

bool	DjinniProcess_chroot(struct DjinniProcess const *self);

#endif	//  H_VSERVER_DJINNIE_SRC_DJINNIPROCESS_RUN_H
